
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Work_centersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const work_centers = await db.work_centers.create(
            {
                id: data.id || undefined,
        
        work_center_name: data.work_center_name
        ||
        null
            ,
            
        work_center_code: data.work_center_code
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return work_centers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const work_centersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                work_center_name: item.work_center_name
            ||
            null
            ,
            
                work_center_code: item.work_center_code
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const work_centers = await db.work_centers.bulkCreate(work_centersData, { transaction });

        // For each item created, replace relation files
        

        return work_centers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const work_centers = await db.work_centers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.work_center_name !== undefined) updatePayload.work_center_name = data.work_center_name;
        
        
        if (data.work_center_code !== undefined) updatePayload.work_center_code = data.work_center_code;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await work_centers.update(updatePayload, {transaction});

        
        

        
        

        

        return work_centers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const work_centers = await db.work_centers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of work_centers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of work_centers) {
                await record.destroy({transaction});
            }
        });


        return work_centers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const work_centers = await db.work_centers.findByPk(id, options);

        await work_centers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await work_centers.destroy({
            transaction
        });

        return work_centers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const work_centers = await db.work_centers.findOne(
            { where },
            { transaction },
        );

        if (!work_centers) {
            return work_centers;
        }

        const output = work_centers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.production_lines_work_center = await work_centers.getProduction_lines_work_center({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.work_center_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'work_centers',
                        'work_center_name',
                        filter.work_center_name,
                    ),
                };
            }
            
            if (filter.work_center_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'work_centers',
                        'work_center_code',
                        filter.work_center_code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'work_centers',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.work_centers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'work_centers',
                        'work_center_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.work_centers.findAll({
            attributes: [ 'id', 'work_center_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['work_center_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.work_center_name,
        }));
    }

    
};

